#include <JUI/UDim.hpp>

JUI::UDim JUI::UDimLiterals::operator ""_scale(long double sc) {
    return {0, static_cast<float>(sc)};
}

JUI::UDim JUI::UDimLiterals::operator ""_percent(unsigned long long pc) {
    return {0, pc/100.f};
}

JUI::UDim JUI::UDimLiterals::operator ""_pixels(unsigned long long px) {
    return {static_cast<int>(px), 0.f};
}

JUI::UDim JUI::UDimLiterals::operator ""_px(unsigned long long px) {
    return {static_cast<int>(px), 0.f};
}

JUI::UDim JUI::UDim::operator+(const UDim &rhs) const {
    return {Pixels + rhs.Pixels, Scale + rhs.Scale};
}

JUI::UDim JUI::UDim::operator-(const UDim &rhs) const {
    return {Pixels - rhs.Pixels, Scale - rhs.Scale};
}

JUI::UDim JUI::UDim::operator*(float rhs) const {
    return {static_cast<int>(Pixels * rhs), Scale*rhs};
}

JUI::UDim JUI::UDim::operator/(float rhs) const {
    return {static_cast<int>(Pixels / rhs), Scale/rhs};
}
