#include <JUI/UDim2.hpp>

JUI::UDim2::UDim2() {
    //X = {0, 0.f};
    //Y = {0, 0.f};
}

JUI::UDim2::UDim2(int px, int py, float sx, float sy) {
    X = {px, sx};
    Y = {py, sy};
}

JUI::UDim2::UDim2(Vector2 pixels, Vector2 scale) {
    X = {static_cast<int>(pixels.x), scale.x};
    Y = {static_cast<int>(pixels.y), scale.y};
}

JUI::UDim2::UDim2(UDim x, UDim y) {
    X = x;
    Y = y;
}

JUI::UDim2 JUI::UDim2::FromPixels(int x, int y) { return {x, y, 0, 0}; }

JUI::UDim2 JUI::UDim2::FromScale(float x, float y) { return {0, 0, x, y}; }

JUI::UDim2 JUI::UDim2::operator+(const UDim2 &rhs) const {
    return {X+rhs.X, Y+rhs.Y};
}

JUI::UDim2 JUI::UDim2::operator-(const UDim2 &rhs) const {
    return {X-rhs.X, Y-rhs.Y};
}

JUI::UDim2 JUI::UDim2::operator*(float rhs) const {
    return {X*rhs, Y*rhs};
}

JUI::UDim2 JUI::UDim2::operator/(float rhs) const {
    return {X/rhs, Y/rhs};
}

Vector2 JUI::UDim2::GetScale() const {
    return {X.Scale, Y.Scale};
}

Vector2 JUI::UDim2::GetPixels() const {
    return {static_cast<float>(X.Pixels), static_cast<float>(Y.Pixels)};
}
